<template>
  <div class="mt-form-fields-activity">
    <div class="mt-fields-section">
      <h3 class="has-text-weight-bold">Informations sur l’activité</h3>
      <b-field label="Organisme de l’activité ">
        <b-select v-model="activite.organisme.id" :value="organisme" placeholder="Choisir un organisme" expanded>
          <optgroup v-for="list in getListeOrganisme()" :key="list[0]" :label="list[0]">
            <option v-for="userOrganisme in list[1]" :key="userOrganisme.id" :value="userOrganisme.id">
              {{ userOrganisme.libelle }}
            </option>
          </optgroup>
        </b-select>
      </b-field>
      <b-field label="Nom de l’activité ">
        <b-input v-model="activite.nom" placeholder="Ex: Activité 1" required />
      </b-field>
      <mt-focus-warning>
        <template #message
          >Ne pas renseigner d’informations relatives à la localisation d’une activité. Indiquez seulement le
          département si nécessaire.</template
        >
        <b-field label="Description">
          <b-input v-model="activite.description" type="textarea" placeholder="Rédigez une description." />
        </b-field>
      </mt-focus-warning>
      <b-field class="mt-fake-field" label="Typologie d'activité"></b-field>
      <b-field class="mt-type">
        <b-radio-button
          v-for="(typeActivite, index) in appTypesActivites"
          :key="index"
          v-model="activite.typeActivite.id"
          :native-value="typeActivite.id"
          :class="resolveTypeActivite({ typeActivite }, 'mt-type-').class"
        >
          <span>{{ typeActivite.libelle }}</span
          >&nbsp;<b-icon :icon="typeActivite.codeCssIcone" />
        </b-radio-button>
      </b-field>
    </div>
    <div class="mt-fields-section">
      <h3 class="has-text-weight-bold">Informations pratiques</h3>
      <b-field label="Début">
        <b-datepicker
          v-model="activite.dateDebut"
          placeholder="Sélectionnez une date de debut"
          :first-day-of-week="1"
          :month-names="monthNames"
          :day-names="dayNames"
          :date-parser="dateParse"
          :disabled="isDatesDisabled"
          editable
          icon="calendar-today"
          @input="majEffectifPrevisionnel"
        />
      </b-field>
      <b-field label="Fin">
        <b-datepicker
          v-model="activite.dateFin"
          placeholder="Sélectionnez une date de fin"
          :first-day-of-week="1"
          :month-names="monthNames"
          :day-names="dayNames"
          :date-parser="dateParse"
          :disabled="isDatesDisabled"
          editable
          icon="calendar-today"
          @input="majEffectifPrevisionnel"
        />
      </b-field>
    </div>
    <div class="mt-fields-section">
      <b-field class="mt-fake-field" label="Effectif potentiel"></b-field>
      <div class="columns is-mobile is-vcentered is-multiline">
        <div v-for="(corp, index) in effectifPrevisionnel.corps" :key="index" class="column is-half-mobile">
          <label class="label label-secondary columns is-vcentered is-mobile">
            <span class="column is-narrow ">{{ corp.libelle }}</span>
            <b class="column is-narrow">{{ corp.count }}</b></label
          >
        </div>
      </div>
    </div>
    <div class="mt-fields-section">
      <b-field class="mt-fake-field" label="Effectif nécessaire"></b-field>
      <div class="columns">
        <div v-for="(effectif, index) in activite.effectifs" :key="index" class="column is-4">
          <b-field :label="effectif.corps.libelle">
            <b-input v-model="effectif.nombre" type="number" min="0" />
          </b-field>
        </div>
      </div>
    </div>
    <div class="mt-fields-section">
      <label class="label">Paramétrer un rappel</label>
      <mt-message-info class="margin-message"
        >Cette option enverra un rappel à tous les pax de votre unité les incitant à déclarer leurs disponibilités et/ou
        à candidater sur cette activité. Ce rappel ne peut pas être modifié.</mt-message-info
      >
      <div class="columns">
        <div class="column is-narrow">
          <b-switch v-model="rappel" class="mt-swith">
            Rappel
          </b-switch>
        </div>
        <div class="column is-narrow">
          <b-checkbox v-model="activite.rappelInApp" :disabled="!rappel" name="rappelinapp">In-App</b-checkbox>
        </div>
        <div class="column is-narrow">
          <b-checkbox v-model="activite.rappelEmail" :disabled="!rappel" name="rappelemail">Par mail</b-checkbox>
        </div>
      </div>
      <div class="columns is-vcentered">
        <div class="column is-2">
          <b-field custom-class="label-secondary">
            <b-input
              v-model="activite.rappelNbJourAvantDebut"
              type="number"
              min="0"
              class="mt-input"
              :disabled="!rappel"
              @input="majDateRappel"
            />
          </b-field>
        </div>
        <div class="column">
          Jours avant la date de début de l’activité <small>({{ majDateRappel() }})</small>.
        </div>
      </div>
    </div>
    <div class="mt-fields-section">
      <label class="label">Paramétrer une alerte de création d’activité </label>
      <mt-message-info class="margin-message"
        >Cette option enverra une alerte par email à tous les pax de votre unité les informant de cette nouvelle
        activité.
      </mt-message-info>
      <div class="columns">
        <div class="column is-narrow">
          <b-switch v-model="activite.envoyerMailCreation" class="mt-swith" :disabled="modifier">
            Alerte par email
          </b-switch>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { DateTime } from 'luxon';
import { classResolver } from '~/components/mixins/activityMixin';
import DayMonthMixin from '~/components/mixins/DayMonthMixin';
import MtMessageInfo from '~/components/base/message/mt-message-info';
import MtFocusWarning from '~/components/base/focus-warning/mt-focus-warning';

export default {
  components: { MtMessageInfo, MtFocusWarning },
  mixins: [classResolver, DayMonthMixin],
  props: {
    activite: {
      type: Object,
      default: () => ({}),
    },
    effectifPrevisionnel: {
      type: Object,
      default: () => ({}),
    },
    organismes: {
      type: Array,
      default: () => [],
    },
    isDatesDisabled: {
      type: Boolean,
      default: false,
    },
    modifier: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      rappel: false,
    };
  },
  methods: {
    majEffectifPrevisionnel() {
      this.$emit('majEffectifPrevisionnel');
    },
    majDateRappel() {
      let start = DateTime.fromJSDate(this.activite.dateDebut);
      start = start.minus({ days: this.activite.rappelNbJourAvantDebut });
      return start.setLocale('fr').toFormat('dd/MM/yyyy');
    },
    getListeOrganisme() {
      const organismes = new Map();
      this.organismes.forEach(function setOrganismes(organisme) {
        let tabOrg = organismes.get(organisme.codeParent);
        if (!tabOrg) {
          tabOrg = [];
        }
        tabOrg.push(organisme);
        organismes.set(organisme.codeParent, tabOrg);
      });
      return Array.from(organismes);
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

h3 {
  font-weight: bold;
  margin-bottom: 1rem;
}
.mt-fields-section {
  margin-bottom: 1.25rem;
}
.mt-fake-field {
  margin-bottom: 0;
}
.mt-form-fields-activity {
  margin-bottom: 2.25rem;
}
.margin-message {
  margin-bottom: 1rem;
}
</style>
